import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCoach, ThinkCoachParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询教练表
 */
export async function pageThinkCoach(params: ThinkCoachParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCoach>>>(
    THINK_API_URL + '/think/think-coach/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询教练表列表
 */
export async function listThinkCoach(params?: ThinkCoachParam) {
  const res = await request.get<ApiResult<ThinkCoach[]>>(
    THINK_API_URL + '/think/think-coach',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加教练表
 */
export async function addThinkCoach(data: ThinkCoach) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改教练表
 */
export async function updateThinkCoach(data: ThinkCoach) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除教练表
 */
export async function removeThinkCoach(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除教练表
 */
export async function removeBatchThinkCoach(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coach/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询教练表
 */
export async function getThinkCoach(id: number) {
  const res = await request.get<ApiResult<ThinkCoach>>(
    THINK_API_URL + '/think/think-coach/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
